#!/bin/bash

##########################################################################
# Copyright 2014 VMware, Inc.  All rights reserved. VMware Confidential
##########################################################################

export PATH=$PATH:/usr/local/staf/bin/
export LD_LIBRARY_PATH=/usr/local/staf/lib/
rm -f /tmp/LAUNCHER-LOG-*.log
Date=$(date +"%b-%d-%y-%H-%M")
STAF_LOG=/tmp/LAUNCHER-LOG-$Date.log
touch $STAF_LOG

echo "$(date +"%b-%d-%y-%H-%M"): entering maintenance mode:" |tee -a $STAF_LOG

ret=`staf local ping ping`
echo $ret|grep 'PONG'
if [ $? -eq 0 ]
then
   echo "$(date +"%b-%d-%y-%H-%M"): staf OK" | tee -a $STAF_LOG
else
   echo "$(date +"%b-%d-%y-%H-%M"): staf DOWN. Reboot launcher" | tee -a $STAF_LOG
   reboot
fi

echo "$(date +"%b-%d-%y-%H-%M"): setting STAF/Env/MAINTENANCE = 1"| tee -a $STAF_LOG
staf local var set system var STAF/Env/MAINTENANCE=1

ret=`staf local var get system var STAF/Env/MAINTENANCE`
echo $ret|grep '1'
if [ $? -eq 0 ]
then
   echo "$(date +"%b-%d-%y-%H-%M"): setting of STAF/Env/MAINTENANCE is successful"  | tee -a $STAF_LOG
else
   echo "$(date +"%b-%d-%y-%H-%M"): setting of STAF/Env/MAINTENANCE fails. Reboot launcher"  | tee -a $STAF_LOG
   reboot
fi

echo "$(date +"%b-%d-%y-%H-%M"): check whether tests within 2 days are running" |tee -a $STAF_LOG
ret=`ps -eo etime,command|grep TestLauncher|grep -v grep|awk --posix '$1 ~/^(1-|[0-9]{2}:[0-9]{2})/' |wc -l`
echo "$(date +"%b-%d-%y-%H-%M"): The number of running jobs within 2 days is $ret"  | tee -a $STAF_LOG

while [ $ret -ne 0 ]
do
    sleep 900
    ret=`ps -eo etime,command|grep TestLauncher|grep -v grep|awk --posix '$1 ~/^(1-|[0-9]{2}:[0-9]{2})/' |wc -l`
    echo "$(date +"%b-%d-%y-%H-%M"): The number of running jobs within 2 days is $ret"  | tee -a $STAF_LOG
done

echo "$(date +"%b-%d-%y-%H-%M"): sleep 10 before reboot" |tee -a $STAF_LOG
sleep 10

echo "$(date +"%b-%d-%y-%H-%M"): reboot" |tee -a $STAF_LOG
reboot

